#ifndef jvmHeap
#define jvmHeap

/*
***********************************
* File jvmHeap: handling the heap *
***********************************
*/

/*
   Values are stored onto the heap using big endian.
   The jvmData methods writeJavaIntBE and readJavaIntBE are used to read/write heap items.
   The heap grows downwards.
   Heappointer points to first free heap byte.
*/

#include "jvmData.c"
  
long allocate(long size) {
  long hp,sp;
/* Allocate a block of size bytes from the heap. */
  hp = getJvmHP();
  sp = getJvmSP();
  if (hp - size > sp) { //enough free space
    hp -= size;
    setJvmHP(hp);
    return hp;
  }
  //not enough memory -> jvm must throw exception
  return 0;
}
  
#endif

